/*                                                                          */
/*                                            */
/*                                           */
/*                     ĲĲĲ                 */
/*                     ĲĲĲĲ                 */
/*                     ĲĲĲĲĲ                 */
/*                     ĲĲĲ                 */
/*                                             */
/*                                               */
/*                      Ŀ                        */
/*                       COMPANY'96                         */
/*                                              */
/*                                                                          */
/*                      DGS COMPANY 96-98  ( ..TRUST US.. )                 */
/*                                                                          */
/* All rights reserved.                                                     */
/* All code was made by HERN                                                */
/* DGS CO'96                                                                */

#include <math.h>
#define sx ((bmaxx-bminx)/2)
#define sy ((bmaxy-bminy)/2)
#define alpha 0.05
#define maxo 20
#define COL 255

typedef struct vector3d
   {
     float x;
     float y;
     float z;
   } v3d;

typedef struct point2d
   {
     float x;
     float y;
   } p2d;

typedef struct face3d
   {
     int a;
     int b;
     int c;
   } f3d;

typedef struct dr_s
  {
    int z;
    int num;
    int n;
    int c;

  } drs;


struct object
   {
      v3d *v;
      f3d *wr;
      p2d *sc;

      int faces;
      int vertices;


   } obj[maxo];

v3d *v;
drs *dr;

int    i,j,no;


int    a,b,c;
int    object_number;
char   done;
char   err;
int    vertices,faces;
int    avertices,afaces;
int    maxobj,ob;




/**/
void calcp2(void)
{
  int n,i;
  float rob,t;

  for (n=0;n<maxobj;n++)
    {

       for (i=0;i<obj[n].vertices;i++)

         {
           t=obj[n].v[i].z+ob;

           if (t!=0) {
           rob=168/t;
           obj[n].sc[i].x= (obj[n].v[i].x*rob+sx);
           obj[n].sc[i].y= (obj[n].v[i].y*rob+sy);
           } else
           {

           obj[n].sc[i].x=0;
           obj[n].sc[i].y=0;
           }
         }

    }
}
/**/
void frot2(char a1,float alfa,int ne)
{
  int i,n;
  float r1,r2,yz,zx;
  float c1,s1,sc1,c2,s2,sc2;
  float x,y,z;

  c1=cos(alfa);
  s1=sin(alfa);
  sc1=c1*s1;

  for (n=0;n<maxobj;n++)

  for (i=0;i<obj[n].vertices;i++)
    switch (a1)
      {
        case 0:

            v=&obj[n].v[i];

            y = v->y;
            z = v->z;

            yz=y*z;


            r1 = (y-s1) * (z+c1) - yz + sc1;
            r2 = (y+c1) * (z+s1) - yz + sc1;

            v->y=r1;
            v->z=r2;

            break;

        case 1:

            v=&obj[n].v[i];

            x = v->x;
            y = v->y;
            z = v->z;

            zx=z*x;


            r1 = (z+c1) * (x+s1) - zx - sc1;
            r2 = (z-s1) * (x+c1) - zx + sc1;

            v->x=r1;
            v->z=r2;

            break;
      }

}
/**/
void scale_object(float s)
{
  int i,n;

  for (n=0;n<maxobj;n++)

     for (i=0;i<obj[n].vertices;i++)
       {
         obj[n].v[i].x*=s;
         obj[n].v[i].y*=s;
         obj[n].v[i].z*=s;
       }


}
/**/
void load_3dg(int name)
{
  int i,j;
  int *ptr;

  ptr=dat[name].dat;
  maxobj=(int) *ptr;
  ptr+=1;

  avertices=0;
  afaces=0;


  for (i=0;i<maxobj;i++)
  {

      obj[i].vertices=(int) *ptr;
      ptr+=1;
      obj[i].faces=(int) *ptr;
      ptr+=1;

      obj[i].v   = (v3d*)  ptr;
      ptr+=obj[i].vertices*3;
      obj[i].wr  = (f3d*)  ptr;
      ptr+=obj[i].faces*3;

      avertices+=obj[i].vertices;
      afaces+=obj[i].faces;

  }

}
/**/
void move_object(float dx,float dy,float dz)
{
  int i,j;
  for (i=0;i<maxobj;i++)
    {
      for (j=0;j<obj[i].vertices;j++)
        {
          obj[i].v[j].x+=dx;
          obj[i].v[j].y+=dy;
          obj[i].v[j].z+=dz;
        }
    }
}
/**/
void draw_objects(void)
{
  int i,j,n;
  int p,nul;
  int a,b,c,col;


  p=-1;
  nul=-1;

  for (n=0;n<maxobj;n++)
    {

       for (i=0;i<obj[n].faces;i++)
         {

           a=obj[n].wr[i].a;
           b=obj[n].wr[i].b;
           c=obj[n].wr[i].c;

           nul=(obj[n].sc[a].x-obj[n].sc[b].x)*(obj[n].sc[c].y-obj[n].sc[b].y)-
               (obj[n].sc[b].x-obj[n].sc[c].x)*(obj[n].sc[b].y-obj[n].sc[a].y);


//           if (nul<0)

           {
             p++;
             dr[p].z=(obj[n].v[a].z+obj[n].v[b].z+obj[n].v[c].z) /3;
             dr[p].num=i;
             dr[p].n=n;

           }
         }

    }


  for (i=0;i<=p;i++)
    {

      n=dr[i].n;


      a=obj[n].wr[dr[i].num].a;
      b=obj[n].wr[dr[i].num].b;
      c=obj[n].wr[dr[i].num].c;


      line(buf,obj[n].sc[a].x,obj[n].sc[a].y,obj[n].sc[b].x,obj[n].sc[b].y,COL);
      line(buf,obj[n].sc[c].x,obj[n].sc[c].y,obj[n].sc[a].x,obj[n].sc[a].y,COL);
      line(buf,obj[n].sc[c].x,obj[n].sc[c].y,obj[n].sc[b].x,obj[n].sc[b].y,COL);

    }
}
/**/

