/*                                                                          */
/*                                            */
/*                                           */
/*                     ĲĲĲ                 */
/*                     ĲĲĲĲ                 */
/*                     ĲĲĲĲĲ                 */
/*                     ĲĲĲ                 */
/*                                             */
/*                                               */
/*                      Ŀ                        */
/*                       COMPANY'96                         */
/*                                              */
/*                                                                          */
/*                      DGS COMPANY 96-98  ( ..TRUST US.. )                 */
/*                                                                          */
/* All rights reserved.                                                     */
/* All code was made by HERN                                                */
/* DGS CO'96                                                                */

#define NUM_POINTS   8+6
#define NUM_FACES    6
#define BUFFER_SIZE  256

typedef struct POINT
{
   float x, y, z;
} POINT;

typedef struct QUAD 
{
   int v1, v2, v3, v4;
   int normal;
   int visible;
} QUAD;

static POINT point[NUM_POINTS] =
{
   { -32, -32, -32 },
   { -32,  32, -32 },
   {  32,  32, -32 },
   {  32, -32, -32 },
   { -32, -32,  32 },
   { -32,  32,  32 },
   {  32,  32,  32 },
   {  32, -32,  32 },
   { -32, -32, -33 },
   { -32, -32,  33 },
   { -33,  32, -32 },
   {  33,  32, -32 },
   {  32, -33,  32 },
   {  32,  33,  32 }
};
static V3D_f vtx[NUM_POINTS] =
{
      { 0, 0, 0, 0,  0,  0x30 },
      { 0, 0, 0, 0,  127, 0x99 },
      { 0, 0, 0, 127,127, 0x55 },
      { 0, 0, 0, 127,  0,  0xDD },
      { 0, 0, 0, 127,  0,  0x40 },
      { 0, 0, 0, 127,  127, 0xBB },
      { 0, 0, 0, 0,  127, 0x77 },
      { 0, 0, 0, 0,  0,  0xF0 }
};

QUAD face[NUM_FACES] = 
{
   { 0, 3, 2, 1, 8  },
   { 4, 5, 6, 7, 9  },
   { 1, 5, 4, 0, 10 },
   { 2, 3, 7, 6, 11 },
   { 7, 3, 0, 4, 12 },
   { 6, 5, 1, 2, 13 }
};


float xr = 0;
float yr = 0;
float zr = 0;
float dist = 175;
MATRIX_f transform, camera;
V3D_f *vertex, *normal;
BITMAP *buffer;
BITMAP *texture0;
BITMAP *texture1;
BITMAP *texture2;
BITMAP *texture3;
BITMAP *texture4;


BITMAP *tex[6];


void draw_cube(void)
{
      int c;
      float vx, vy, vz;
      float nx, ny, nz;

      clear_to_color(buffer, 0);

      get_transformation_matrix_f(&transform, 1, xr, yr, zr, 0, 0, dist);

      for (c=0; c<NUM_POINTS; c++)
        apply_matrix_f(&transform, point[c].x, point[c].y, point[c].z, &vtx[c].x, &vtx[c].y, &vtx[c].z);

      for (c=0; c<NUM_FACES; c++)
        {
      	 vertex = &vtx[face[c].v1];
      	 normal = &vtx[face[c].normal];
      	 vx = vertex->x;
      	 vy = vertex->y;
      	 vz = vertex->z;
      	 nx = normal->x - vx;
      	 ny = normal->y - vy;
      	 nz = normal->z - vz;
      	 if (dot_product_f(vx, vy, vz, nx, ny, nz) < 0)
      	    face[c].visible = TRUE;
      	 else
      	    face[c].visible = FALSE;
        }

      for (c=0; c<NUM_POINTS; c++)
        {
      	 apply_matrix_f(&camera, vtx[c].x, vtx[c].y, vtx[c].z, &vtx[c].x, &vtx[c].y, &vtx[c].z);
          persp_project_f(vtx[c].x, vtx[c].y, vtx[c].z, &vtx[c].x, &vtx[c].y);
        }


      for (c=0; c<NUM_FACES; c++)
        {
          if (face[c].visible) {
	         quad3d_f(buffer, POLYTYPE_ATEX, tex[c],
		               &vtx[face[c].v1], &vtx[face[c].v2],
                     &vtx[face[c].v3], &vtx[face[c].v4]);
        	 }
        }
}

void edu_go(void)

{
  int i,j,k=0;
  float sint[360];
  PALETTE pal0;

  memcpy(pal0,dat[pal1].dat,sizeof(pal0));
  buffer = create_bitmap(BUFFER_SIZE, BUFFER_SIZE);

  texture0=dat[dgs_log].dat;
  texture1=create_bitmap(128,128);
  texture2=create_bitmap(128,128);
  texture3=create_bitmap(128,128);
  texture4=create_bitmap(128,128);

  rect(texture0,0,0,127,127,255);
  rect(texture0,1,1,126,126,255);


  /* TEXTURE 2 */
  clear_to_color(texture1,20);

  for (i=0;i<50;i++)
   line(texture1,0,i,128,i,80);
  for (i=79;i<128;i++)
   line(texture1,0,i,128,i,80);

  rect(texture1,0,0,127,127,255);
  rect(texture1,1,1,126,126,255);
  text_mode(-1);
  textout_centre(texture1,f_c,"PREZENTUJE",64,52,-1);
  line(texture1,1,50,126,50,255);
  line(texture1,1,78,126,78,255);

  draw_sprite_h_flip(texture2,texture1,0,0);

  /* TEXTURE 3 */
  clear(texture1);
  clear_to_color(texture3,0);

  rectfill(texture1,1,50,127,78,80);
  rect(texture1,1,50,127,78,255);

  rect(texture1,0,0,127,127,255);
  rect(texture1,1,1,126,126,255);

  textout_centre(texture1,f_c,"PROGRAM",64,10,195);
  textout_centre(texture1,f_c,"O BRYLACH",64,52,-1);
  textout_centre(texture1,f_c,"NAZWANY",64,90,195);

  draw_sprite(texture3,texture1,0,0);

  /* TEXTURE 4 */
  clear(texture1);
  clear_to_color(texture4,80);
  rect(texture1,0,0,127,127,255);
  rect(texture1,1,1,126,126,255);

  textout(texture1,f_c,"X",40,52,-1);
  textout(texture1,f_d0,"FORMS",50,58,-1);
  textout_centre(texture1,font,"v.0.9",68,75,255);

  draw_sprite_h_flip(texture4,texture1,0,0);



  for (i=0;i<NUM_FACES;i++) tex[i]=texture0;

  tex[3]=texture2;
  tex[1]=texture3;
  tex[2]=texture4;

  for (i=0;i<360;i++) sint[i]=sin((float)i*3.1415/180.0)*i*3.14/180;


  i=0;


  set_projection_viewport(0, 0, BUFFER_SIZE, BUFFER_SIZE);

  get_camera_matrix_f(&camera,
     0, 0, 0,
     0, 0, 1,
     0, -1, 0,
     32,
     1);



  while (yr>-192.399)
  {

    draw_cube();
    vsync();
    blit(buffer, screen, 0, 0,
    (SCREEN_W-BUFFER_SIZE)/2,
    (SCREEN_H-BUFFER_SIZE)/2, BUFFER_SIZE, BUFFER_SIZE);

    yr-=0.4;

  }

  i=180;
  while (k!=63)
  {

    draw_cube();
    vsync();
    blit(buffer, screen, 0, 0,
    (SCREEN_W-BUFFER_SIZE)/2,
    (SCREEN_H-BUFFER_SIZE)/2, BUFFER_SIZE, BUFFER_SIZE);
    i++;
    if (i>360) i=0;

    dist+=4;
    yr+=sint[i];
    zr+=sint[i];

    for (j=0;j<256;j++)
      {
        if (pal0[j].r>0) pal0[j].r--;
        if (pal0[j].g>0) pal0[j].g--;
        if (pal0[j].b>0) pal0[j].b--;

      }
    k++;

    set_palette(pal0);

  }

  destroy_bitmap(buffer);
  destroy_bitmap(texture0);
  destroy_bitmap(texture1);
  destroy_bitmap(texture2);
  destroy_bitmap(texture3);
  destroy_bitmap(texture4);
}
