#include <string.h>
#include <stdio.h>
#include <allegro.h>
DECLARE_GFX_DRIVER_LIST(
GFX_DRIVER_VESA2L
);

DECLARE_COLOR_DEPTH_LIST(
COLOR_DEPTH_8
);

#define STEPX 9
#define STEPY 9
#define MSGY 467
#define MSGX 5

int i,j;
int px,py;
int wx,wy;
int k,k1;
int x1,x2,y1,y2;
int lmax=0;
int ltext=0;
int lcirc=0;

int col=255;

int LINE=0;
int CIRCLE=0;
int BOLD=0;
int WIN=0;
int DELETE=0;
int REDRAW=0;
int NUMBERS=0;
int TEXT=0;

char filename[12];

struct
 {
   int x1,y1;
   int x2,y2;
   int type;
   int col;

 } lines[200];

struct
 {
   int length;
   char text[256];
   int x,y;
 } text[50];

char str[256];

struct
 {
   int x,y,r1,r2;
   int type;
   int col;
 } circles[50];

char str[256];

int DO_CIRCLE=0;
int DO_LINE=1;
int DO_TEXT=0;
int NOW=0;

int rx,ry;

int file;
FILE *f;
RGB c255={63,63,63};
RGB c195={63,63,00};
BITMAP *buff;
/**/
void scale(float s)
{
  for (i=0;i<lmax;i++)
    {
      lines[i].x1*=s;
      lines[i].x2*=s;
      lines[i].y1*=s;
      lines[i].y2*=s;
    }
  for (i=0;i<ltext;i++)
    {
      text[i].x*=s;
      text[i].y*=s;
    }
  for (i=0;i<ltext;i++)
    {
      circles[i].x*=s;
      circles[i].y*=s;
      circles[i].r1*=s;
      circles[i].r2*=s;
    }
}
/**/
void scaled(float s)
{
  for (i=0;i<lmax;i++)
    {
      lines[i].x1/=s;
      lines[i].x2/=s;
      lines[i].y1/=s;
      lines[i].y2/=s;
    }
  for (i=0;i<ltext;i++)
    {
      text[i].x/=s;
      text[i].y/=s;
    }
  for (i=0;i<ltext;i++)
    {
      circles[i].x/=s;
      circles[i].y/=s;
      circles[i].r1/=s;
      circles[i].r2/=s;
    }
}
/**/
int save(char *filename)
{


  f=fopen(filename,"wb");
  if (f==NULL) return -1;

  scaled(9);

  fwrite(&lmax,sizeof(lmax),1,f);
  fwrite(&lines,sizeof(lines[0]),lmax,f);
  fwrite(&ltext,sizeof(ltext),1,f);
  for (i=0;i<ltext;i++)
    {
      fwrite(&text[i].x,4,1,f);
      fwrite(&text[i].y,4,1,f);
      fwrite(&text[i].length,4,1,f);
      fwrite(&text[i].text,1,text[i].length,f);
    }
  fwrite(&lcirc,sizeof(lcirc),1,f);
  fwrite(&circles,sizeof(circles[0]),lcirc,f);


  fclose(f);

  scale(9);

}
/**/
int load(char *filename)
{

  f=fopen(filename,"rb");
  if (f==NULL) return -1;
  else {

  fread(&lmax,4,1,f);
  fread(lines,sizeof(lines[0]),lmax,f);
  fread(&ltext,4,1,f);

  for (i=0;i<ltext;i++)
    {
      fread(&text[i].x,4,1,f);
      fread(&text[i].y,4,1,f);
      fread(&text[i].length,4,1,f);
      fread(&text[i].text,1,text[i].length,f);
    }

  if (!feof(f))
  {
  fread(&lcirc,sizeof(lcirc),1,f);
  fread(&circles,sizeof(circles[0]),lcirc,f);
  }

  fclose(f);

  scale(9);
  return 0;
  }

}
/**/
void cursor(int x,int y)
{
  xor_mode(TRUE);
  vline(screen,x,y-2,y+8,15);
  xor_mode(FALSE);

}
/**/
void getstr(int x,int y,char *str,int maxchar)
{
  int minx,maxx;
  int i;
  int k,k1;
  char ch[2];

  rectfill(screen,x-1,y-5,x+maxchar*8,y+11,0);

  textout(screen,font,str,x,y,15);

  minx=x;
  maxx=8*maxchar+x;

  x=x+text_length(font,str);



  i=0;
  while (*(str+i)!=0) i++;

  k=0;
  cursor(x,y);

  do {


       k1=readkey();
       k=k1 >> 8;

       if (k!=KEY_ENTER && k!=KEY_ESC && k!=KEY_BACKSPACE &&
           k!=KEY_UP    && k!=KEY_DOWN && k!=KEY_LEFT && k!=KEY_RIGHT && x<maxx)
         {
           ch[0]=k1 & 0xff;
           ch[1]=0;
           *(str+i)=ch[0];
           cursor(x,y);
           textout(screen,font,ch,x,y,15);
           i++;
           x+=8;
           cursor(x,y);


         }

       if (k==KEY_BACKSPACE && x>minx)
         {
           cursor(x,y);
           i--;
           x-=8;
           *(str+i)=0;
           text_mode(0);
           textout(screen,font," ",x,y,0);
           text_mode(-1);
           cursor(x,y);
         }




  } while (k!=KEY_ENTER);

  *(str+i)=0;
  cursor(x,y);

}
/**/
void show_numbers(void)
{
  int px1,py1,px2,py2;

  int px,py;

  for (i=0;i<lmax;i++)
    {
      px=(lines[i].x1+lines[i].x2)/2;
      py=(lines[i].y1+lines[i].y2)/2;

      rectfill(screen,px-9,py-5,px+9,py+5,4);
      textprintf_centre(screen,font,px+1,py-3,14,"%d",i+1);

    }

}
/**/
void clear_screen(void)
{
  int px,py;

  vsync();
  rectfill(screen,0,0,639,459,0);
//  clear(screen);
  vsync();

  py=0;

  for (j=0;j<51;j++)
    {

        px=0;
        for (i=0;i<72;i++)
         {
             _putpixel(screen,px,py,7);
             px+=STEPX;
         }

        py+=STEPY;

    }
}
/**/
void bline(int x1,int y1,int x2,int y2,int col)
{
  line(screen,x1,y1,x2,y2,col);

  if (BOLD)
  if (y1==y2)
  {
    line(screen,x1,y1+1,x2,y2+1,col);
    line(screen,x1,y1-1,x2,y2-1,col);
  } else
  {
    line(screen,x1+1,y1,x2+1,y2,col);
    line(screen,x1-1,y1,x2-1,y2,col);
  }

}
/**/
void bellipse(int x,int y,int rx,int ry,int col)
{
  ellipse(screen,x,y,rx,ry,col);

  if (BOLD)
  {
    ellipse(screen,x,y,rx-1,ry-1,col);
  }
}
/**/
void redraw(void)
{
  int tbold;

  blit(screen,buff,0,460,0,0,640,20);

  clear_screen();

  tbold=BOLD;

  for (i=0;i<lmax;i++)
    {


      if (lines[i].type) BOLD=1; else BOLD=0;
      bline(lines[i].x1,lines[i].y1,lines[i].x2,lines[i].y2,lines[i].col);


    }
  for (i=0;i<ltext;i++)
    {


      textout(screen,font,text[i].text,text[i].x,text[i].y,15);
      circle(screen,text[i].x,text[i].y,2,13);

    }

  for (i=0;i<lcirc;i++)
    {


      if (circles[i].type) BOLD=1; else BOLD=0;

      bellipse(circles[i].x,circles[i].y,
               circles[i].r1,circles[i].r2,circles[i].col);

      circle(screen,circles[i].x,circles[i].y,2,14);
    }

  if (NUMBERS) show_numbers();

  blit(buff,screen,0,0,0,460,640,20);
  BOLD=tbold;
}
/**/
void draw_cursor(const x,const y)
{

  xor_mode(TRUE);

  vline(screen,x,y-5,y+5,9);
  vline(screen,x+1,y-5,y+5,9);
  vline(screen,x-1,y-5,y+5,9);
  hline(screen,x-5,y,x+5,9);
  hline(screen,x-5,y-1,x+5,9);
  hline(screen,x-5,y+1,x+5,9);

  xor_mode(FALSE);


}
/**/
void xor_line(int x1,int y1,int x2,int y2)
{
  xor_mode(TRUE);
  bline(x1,y1,x2,y2,9);

  xor_mode(FALSE);
}
/**/
void xor_circ(int x,int y,int rx,int ry)
{
  int lx,ly;
  xor_mode(TRUE);
  lx=ABS(rx)*9;
  ly=ABS(ry)*9;
  bellipse(x,y,lx,ly,9);

  line(screen,x-lx,y,x+lx,y,9);
  line(screen,x,y-ly,x,y+ly,9);

  xor_mode(FALSE);
}
/**/
void message(char *str)
{
  rectfill(screen,0,461,568,478,4);
  textout(screen,font,str,MSGX,MSGY,14);
}
/**/
void printl(int num)
{
  textprintf(screen,font,MSGX+70,MSGY,14,"%d",num);
}
/**/
void help(void)
{

  BITMAP *buff=create_bitmap(251,301);

  blit(screen,buff,0,0,0,0,251,301);

  rectfill(screen,0,0,250,300,4);
  textout(screen,font,"L-load file",5,5,15);
  textout(screen,font,"W-write file",5,15,15);
  textout(screen,font,"R-redraw screen",5,25,15);
  textout(screen,font,"B-set bold line",5,35,15);
  textout(screen,font,"S-show line numbers",5,45,15);
  textout(screen,font,"ENTER-start & end drawing line",5,55,15);
  textout(screen,font,"ESC-quit the programm",5,65,15);
  textout(screen,font,"F1-show this help",5,75,15);
  textout(screen,font,"FILE STRUCTURE",5,95,15);
  textout(screen,font,"lmax (int) ",5,105,15);
  textout(screen,font,"x1   (int)",5,115,15);
  textout(screen,font,"y1   (int)",5,125,15);
  textout(screen,font,"x2   (int)",5,135,15);
  textout(screen,font,"y2   (int)",5,145,15);
  textout(screen,font,"type (int)",5,155,15);
  textout(screen,font,"col  (int)",5,165,15);
  textout(screen,font,"EDU DRAWER v.0.9 - 02.04.98",5,275,15);
  textout(screen,font,"CODE BY HERN     - DGS CO'96",5,285,15);

  while (!keypressed());
  clear_keybuf();

  blit(buff,screen,0,0,0,0,251,301);
  destroy_bitmap(buff);
}
/**/
void move(int k)
{
  int x,y;
  x=0;y=0;

  switch (k)
   {
     case KEY_UP    :y=-STEPY;break;
     case KEY_DOWN  :y=STEPY;break;
     case KEY_LEFT  :x=-STEPX;break;
     case KEY_RIGHT :x=STEPX;break;
   }

  for (i=0;i<lmax;i++)
   {
     lines[i].y1+=y;
     lines[i].y2+=y;
     lines[i].x1+=x;
     lines[i].x2+=x;
   }
  for (i=0;i<lcirc;i++)
   {
     circles[i].y+=y;
     circles[i].x+=x;
   }
  for (i=0;i<ltext;i++)
   {
     text[i].y+=y;
     text[i].x+=x;
   }

  redraw();
}
/**/
char l1str[4]="";
char l2str[4]="";
int  l1,l2;
int  lx,ly;
int  OUTX=0,OUTY=0;
int  rx,ry;
int  tcol;
int  load_by_run=0;

int main(int argc, char *argv[])
{

  if (argc>1)
    {
      printf("Loading file : %s\n",argv[1]);
      if (load(argv[1])==-1)
        {
          printf("ERROR LOADING FILE!\n");
          return 1;
        }
      else
      {
       load_by_run=1;
       strcpy(filename,argv[1]);
      }
    }



  allegro_init();
  install_keyboard();
  set_gfx_mode(GFX_AUTODETECT,640,480,0,0);
  text_mode(-1);

  set_color(255,&c255);
  set_color(195,&c195);

  clear_screen();

  buff=create_bitmap(640,20);

  rectfill(screen,0,460,639,479,4);
  hline(screen,0,460,639,15);
  hline(screen,0,479,639,15);

  message("EDU DRAWER v.0.9 - Code by HERN");

  vline(screen,569,460,479,15);
  vline(screen,600,460,479,15);

  rectfill(screen,570,461,599,478,15);
  textprintf_centre(screen,font,585,MSGY,0,"%d",col);

 // load("gr_gfx1.ed1");

  textout(screen,font,"B",605,MSGY,12);
  textout(screen,font,"D",605+10,MSGY,12);

  if (load_by_run) redraw();

  px=315;
  py=234;

  draw_cursor(px,py);
  do {

     k1=readkey();
     k=k1 >> 8;

     draw_cursor(px,py);
     if (LINE)
       xor_line(x1,y1,px,py);
     if (CIRCLE)
       xor_circ(x1,y1,lx,ly);

     if (key_shifts==KB_CTRL_FLAG)
       {
         if (k == KEY_UP   ) move(KEY_UP);
         if (k == KEY_DOWN ) move(KEY_DOWN);
         if (k == KEY_LEFT ) move(KEY_LEFT);
         if (k == KEY_RIGHT) move(KEY_RIGHT);

         if (k == KEY_C)
           {

             memset(l1str,0,sizeof(l1str));
             memset(l2str,0,sizeof(l1str));
             message("CHANGE :     WITH:");
             getstr(5+8*8,466,l1str,3);
             getstr(5+18*8,466,l2str,3);

             l1=atoi(l1str);
             l2=atoi(l2str);

             if (l1==0 || l2==0 || l1>lmax || l2>lmax ||
                 l1<1  || l2<1)
               message("WRONG NUMBERS!");
             else
               {
                 l1--;
                 l2--;

                 memcpy(&lines[199],&lines[l1],sizeof(lines[0]));
                 memcpy(&lines[l1],&lines[l2],sizeof(lines[0]));
                 memcpy(&lines[l2],&lines[199],sizeof(lines[0]));

                 redraw();

               }

           }
         k=0;
       }
     if (k == KEY_LEFT)  if (px>0)  {px-=STEPX;lx--;}
     if (k == KEY_RIGHT) if (px<639) {px+=STEPX;lx++;}
     if (k == KEY_UP)    if (py>0)   {py-=STEPY;ly--;}
     if (k == KEY_DOWN)  if (py<449) {py+=STEPY;ly++;}

     if (k == KEY_F2)
       {
          col=195;
          rectfill(screen,570,461,599,478,col);
          textprintf_centre(screen,font,585,466,0,"%d",col);
       }
     if (k == KEY_F3)
       {
          col=255;
          rectfill(screen,570,461,599,478,col);
          textprintf_centre(screen,font,585,466,0,"%d",col);

       }

     if (k == KEY_C)     {lmax=0;ltext=0;lcirc=0;clear_screen();}
     if (k == KEY_F1)    help();
     if (k == KEY_ESC)
       {
         if (LINE) {LINE=0;k=0;}
         if (CIRCLE) {CIRCLE=0;k=0;}
       }
     if (k == KEY_R)     redraw();
     if (k == KEY_W)
       {
         message("FILE NAME :");
         getstr(MSGX+11*8,MSGY,filename,12);
         if (save(filename)==-1)
         message("FILE WRITING ERROR");
           else
         message("FILE SAVED");
       }
     if (k == KEY_L)
       {
         LINE=0;
         CIRCLE=0;
         message("FILE NAME :");
         getstr(MSGX+11*8,MSGY,filename,12);
         if (load(filename)==-1) message("ERROR LOADING FILE");
         else
          {
            message("FILE LOADED");
            redraw();
          }
       }
     if (k == KEY_PLUS_PAD)
       {
          col++;
          if (col>255) col=15;

          rectfill(screen,570,461,599,478,col);
          textprintf_centre(screen,font,585,MSGY,0,"%d",col);

       };
     if (k == KEY_MINUS_PAD)
       {
          col--;
          if (col<0) col=0;

          rectfill(screen,570,461,599,478,col);
          textprintf_centre(screen,font,585,MSGY,0,"%d",col);

       };
     if (k == KEY_S)
       {
         NUMBERS=!NUMBERS;
         redraw();
       }

     if (k == KEY_D)
       {
          DELETE=!DELETE;
          if (DELETE) tcol=14; else tcol=12;
          textout(screen,font,"D",605+10,MSGY,tcol);
       }
     if (k == KEY_B)
       {
          BOLD=!BOLD;

          if (BOLD) tcol=14; else tcol=12;
          textout(screen,font,"B",605,MSGY,tcol);

       }
     if (k == KEY_F9)
       {
         DO_LINE=1;
         DO_CIRCLE=0;
         DO_TEXT=0;
         CIRCLE=0;
         LINE=0;
       }
     if (k == KEY_F10)
       {
         DO_LINE=0;
         DO_CIRCLE=1;
         DO_TEXT=0;
         CIRCLE=0;
         LINE=0;
         NOW=1;
       }
     if (k == KEY_F11)
       {
         DO_TEXT=1;
         DO_LINE=0;
         DO_CIRCLE=0;
         CIRCLE=0;
         LINE=0;
         NOW=1;
       }

     if (k == KEY_ENTER)
       {

         if (DO_CIRCLE && !DELETE)

           if (CIRCLE)
           {

             CIRCLE=0;
             message("EDU DRAWER v.0.9 - Code by HERN");

             if (lx!=0 && ly!=0)
               {

                 rx=ABS(lx)*9;
                 ry=ABS(ly)*9;
                 bellipse(x1,y1,rx,ry,col);
                 circle(screen,x1,y1,2,14);
                 circles[lcirc].r1=rx;
                 circles[lcirc].r2=ry;
                 circles[lcirc].col=col;
                 if (BOLD)
                   circles[lcirc].type=1;
                 else
                   circles[lcirc].type=0;
                 lcirc++;if (lcirc>49) lcirc=49;
               }

  
           }
           else
           {
             x1=px;
             y1=py;
             lx=0;
             ly=0;
             rx=0;
             ry=0;
  
  
             circles[lcirc].x=x1;
             circles[lcirc].y=y1;
  
  
             CIRCLE=1;
             if (!DELETE)
               {
  
                 message("CIRCLE");
                 printl(lcirc+1);
               }
           }

         if (DO_LINE)


           if (LINE)
           {
             LINE=0;
             NOW=1;
  
             message("EDU DRAWER v.0.9 - Code by HERN");
  
             if (!DELETE)
             if (!(px==x1 && py==y1))
               {

                 bline(x1,y1,px,py,col);
                 lines[lmax].x2=px;
                 lines[lmax].y2=py;
                 lines[lmax].col=col;
                 if (BOLD)
                   lines[lmax].type=1;
                 else
                   lines[lmax].type=0;


                 lmax++;if (lmax>199) lmax=199;
                 if (NUMBERS) show_numbers();
               }
  
           }
           else
           {
             x1=px;
             y1=py;
             lx=0;
             ly=0;
  
  
             lines[lmax].x1=x1;
             lines[lmax].y1=y1;
  
  
             LINE=1;
             if (!DELETE)
               {
  
                 message("LINE");
                 printl(lmax+1);
               }
           }

         if (DO_TEXT && !DELETE)
           {

             message("TEXT :");
             getstr(MSGX+6*8,MSGY,str,64);
             text[ltext].x=px;
             text[ltext].y=py;
             text[ltext].length=strlen(str)+1; // FOR END OF TEXT MARK
             strcpy(text[ltext].text,str);
             ltext++;
             textout(screen,font,str,px,py,15);
             circle(screen,px,py,2,13);
             message("EDU DRAWER v.0.9 - Code by HERN");

           }


         if (DELETE && NOW)
           {
             if (DO_LINE)
             for (i=0;i<lmax;i++)
               {

                 if ((x1==lines[i].x1 &&
                      y1==lines[i].y1 &&
                      px==lines[i].x2 &&
                      py==lines[i].y2 ) ||

                     (x1==lines[i].x2 &&
                      y1==lines[i].y2 &&
                      px==lines[i].x1 &&
                      py==lines[i].y1    ))
                 {
                   memcpy(&lines[i],&lines[i+1],(lmax-i)*sizeof(lines[0]));
                   lmax--;
                   break;

                 }
               }

             if (DO_TEXT)
             for (i=0;i<ltext;i++)
               {

                 if  (px==text[i].x &&
                      py==text[i].y)
                 {
                   memcpy(&text[i],&text[i+1],(ltext-i)*sizeof(text[0]));
                   ltext--;
                   break;

                 }

               }
             if (DO_CIRCLE)
             for (i=0;i<lcirc;i++)
               {

                 if  (px==circles[i].x && py==circles[i].y)

                 {
                   memcpy(&circles[i],&circles[i+1],(lcirc-i)*sizeof(circles[0]));
                   lcirc--;
                   break;
                 }

               }

             redraw();


           }
       }

     draw_cursor(px,py);
     if (LINE)
       {
         xor_line(x1,y1,px,py);
         rectfill(screen,450,461,568,478,4);
         textprintf(screen,font,475,MSGY,15,"X: %d Y: %d",ABS(lx),ABS(ly));
       }
     if (CIRCLE)
       {
         xor_circ(x1,y1,lx,ly);
         rectfill(screen,450,461,568,478,4);
         textprintf(screen,font,475,MSGY,15,"X: %d Y: %d",ABS(lx),ABS(ly));
       }


  } while (k!=KEY_ESC);



  allegro_exit();
  destroy_bitmap(buff);
  return 0;

}
