#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <allegro.h>
#include "setup.h"

DECLARE_GFX_DRIVER_LIST(
GFX_DRIVER_VESA2L
GFX_DRIVER_VESA2B
GFX_DRIVER_VESA1
);
DECLARE_COLOR_DEPTH_LIST(COLOR_DEPTH_8);

char *p;
DATAFILE *dat;


void copy(char *f1,char *f2)
{
  FILE *file1;
  FILE *file2;
  char b;
  int j;
  float d;
  float i=0;
  int l;

  file1=fopen(f1,"rb");
  file2=fopen(f2,"wb");


  l=file_size(f1);

  d=(580-300)/ (float) l;

  for (j=0;j<l;j++)
    {
       fread(&b,1,1,file1);
       fwrite(&b,1,1,file2);
       vline(screen,300+i,225,255,129);
       i+=d;
    }


  fclose(file1);
  fclose(file2);



}

int main(void)
{

  char *dest;
  char *cur_dir;
  char *s,*s0;
  int fs;

  allegro_init();
  dat=load_datafile("setup.dat");


  install_timer();
  install_mouse();
  install_keyboard();
  set_gfx_mode(GFX_AUTODETECT,640,480,0,0);
  set_palette(dat[pal].dat);
  check_cpu();

  blit(dat[bg].dat,screen,0,0,0,0,640,480);
  text_mode(-1);
  rectfill(screen,10,15,630,45,80);
  rect(screen,10,15,630,45,255);
  textout(screen,dat[f_c].dat,"SETUP",20,17,-1);
  textout(screen,dat[f_c].dat,"X-FORMS v.0.9",500,17,-1);

  rectfill(screen,10,395,190,465,80);
  rect(screen,10,395,190,465,255);
  switch (cpu_family)
    {
      case 4:textout(screen,dat[f_c].dat,"CPU : 486",20,395,-1);break;
      case 5:textout(screen,dat[f_c].dat,"CPU : PENTIUM",20,395,-1);break;

    }
  switch (cpu_fpu)
    {
      case TRUE:textout(screen,dat[f_c].dat,"FPU : JEST",20,415,-1);break;
      case FALSE:textout(screen,dat[f_c].dat,"FPU : BRAK",20,415,-1);break;
    }
  switch (cpu_mmx)
    {
      case TRUE:textout(screen,dat[f_c].dat,"MMX : JEST",20,435,-1);break;
      case FALSE:textout(screen,dat[f_c].dat,"MMX : BRAK",20,435,-1);break;
    }


  p=(char *) malloc(256);
  memset(p,0,256);
  strcat(p,"c:/");

  gui_bg_color=195;
  gui_fg_color=0;
  file_select("WYBIERZ KATALOG",p,"");
  text_mode(-1);

  dest=(char *) malloc(256);
  s=(char *) malloc(256);
  cur_dir=(char *) malloc(256);

  memset(dest,0,256);
  strcpy(dest,p);
  s0=s;
  s=dest;
  while (*s)
  {

    if (*s=='\\') *s='/';
    s++;

  }
  s=s0;
  strcat(dest,"XFORMS09/");
  mkdir(dest,0);

  getcwd(cur_dir,256);
  strcat(cur_dir,"/");
  strupr(cur_dir);


  memset(s,0,256);
  strcpy(s,dest);
  strcat(s,"XFORMS09.EXE");

  rectfill(screen,50,210,590,270,196);
  rect(screen,50,210,590,270,0);
  rect(screen,300-1,225-1,580+1,255+1,255);
  textout(screen,dat[f_n].dat,"Kopiowanie   XFORMS09.EXE ...",60,230,0);
  copy("xforms09.exe",s);

  memset(s,0,256);
  strcpy(s,dest);
  strcat(s,"XFORMS09.DAT");

  rectfill(screen,50,210,590,270,196);
  rect(screen,50,210,590,270,0);
  rect(screen,300-1,225-1,580+1,255+1,255);
  textout(screen,dat[f_n].dat,"Kopiowanie   XFORMS09.DAT ...",60,230,0);

  copy("xforms09.dat",s);

  memset(s,0,256);
  strcpy(s,dest);
  strcat(s,"cwsdpmi.exe");

  rectfill(screen,50,210,590,270,196);
  rect(screen,50,210,590,270,0);
  rect(screen,300-1,225-1,580+1,255+1,255);
  textout(screen,dat[f_n].dat,"Kopiowanie   CWSDPMI.EXE ...",60,230,0);

  copy("cwsdpmi.exe",s);

  memset(s,0,256);
  strcpy(s,dest);
  strcat(s,"FILE_ID.DIZ");

  rectfill(screen,50,210,590,270,196);
  rect(screen,50,210,590,270,0);
  rect(screen,300-1,225-1,580+1,255+1,255);
  textout(screen,dat[f_n].dat,"Kopiowanie   FILE_ID.DIZ ...",60,230,0);

  copy("file_id.diz",s);

  fflush(stdout);

  blit(dat[bg].dat,screen,50,160,50,160,590-50+1,320-160+1);
  rectfill(screen,100,200,540,280,80);
  rect(screen,100,200,540,280,255);
  textout_centre(screen,dat[f_c].dat,"INSTALACJA ZAKONCZONA",320,220,-1);
  textout_centre(screen,font,"...Dowolny klawisz to koniec...",320,250,255);

  chdir(dest);

  readkey();

  allegro_exit();

  unload_datafile(dat);

  free(dest);
  free(s);
  free(p);
  free(cur_dir);
  return 0;

}
